Subject: Re: Upstream Homa?

From: Stephen Hemminger <[email-masked]>
Date: Thu, 10 Nov 2022 13:25:40 -0800

On Thu, 10 Nov 2022 11:42:35 -0800
John Ousterhout <[email-masked]> wrote:

> Several people at the netdev conference asked me if I was working to
> upstream the Homa transport protocol into the kernel. I have assumed
> that this is premature, given that there is not yet significant usage of
> Homa, but they encouraged me to start a discussion about upstreaming
> with the netdev community.
> 
> So, I'm sending this message to ask for advice about (a) what state
> Homa needs to reach before it would be appropriate to upstream it,
> and, (b) if/when that time is reached, what is the right way to go about it.
> Homa currently has about 13K lines of code, which I assume is far too
> large for a single patch set; at the same time, it's hard to envision a
> manageable first patch set with enough functionality to be useful by itself.
> 
> -John-

There are lots of experimental protocols already in Linux.
The usual upstream problem areas are:
 - coding style

 - compatibility layers
   developers don't care about code to run on older versions or other OS.
   
 - user API
   once you define it hard to change, need to get it right

 - tests
   is there a way to make sure it works on all platforms

Heuristics and bug fixing are fine, in fact having a wider community
will help.